/*
 *	Muller Lyer Method of Adjustment
 *
 */

console.log('Muller Lyer Method of Adjustment');
var debugIt = 0;	//	1 = true, 0 = false
var emptyStr = "";
var keycode0;
var keycode1;
var keycode2;

function load() {

	$('#lab_space').css( {'position':'relative', 'left':0 } );				
	
    canvas = document.getElementById("lab_display");
    ctx = canvas.getContext("2d");
    enhanceContext(canvas, ctx);	// for retina displays
 	ctx.font="24px Helvetica"; 	// "italic small-caps bold 12px arial";
	ctx.fillStyle="#000000";
	ctx.fillRect(0,0,width,height);
		
	var ttg = numberOfTrials+numPracticeTrials;
	$('#trialsToGo').html('<p>Trials to go: ' + ttg + '</p>');

	/*
	 * binds the keydown event to keydownControl which means that keydownControl 
	 * function will be called whenever any key is pressed
	 */
    window.onkeydown = keydownControl;
    
	
	// Note the time, in milliseconds since the epoch
	labStartTime = new Date().getTime();
	DefineTrials();
}

/*
 *	Needs to be called *after* plotting 
 */
function showAccordian() {
	$( "#accordion" ).accordion({
		active: 0,
		collapsible: true,
		heightStyle: "content"
	});
}

/*
 *	Global Variables
 */

var canvas;
var ctx;
var width = 900;
var height = 600;

var startBut;
var matchBut;

var theTrial;	/* used for cancelling the trial if the user responds too soon */
var currentTrial;

var NOT_IN_TRIAL = 0;
var WAITING_FOR_STIMULUS = 1;
var WAITING_FOR_RESPONSE = 2;
var PROCESSING_RESPONSE = 3;
var END_OF_LAB = 9;

var distractorType = 0;	/* 1 = feature; 2 = conjunction */
var presabs = 0;		/* 1 = present; 2 = absent */

var whichPhase = NOT_IN_TRIAL;

var labStartTime = 0;
var labEndTime = 0;
var trialStartTime = 0;
var trialEndTime = 0;

var numberOfTrials = 10; 
var trialCounter = 0;
var numDistractors = 0;
var TargetStatus = "Present";
var numberOfConditions = 3;

var TrialsToGo = [];
var TrialsDone = [];
var thisTrialIndex;

var theLength= 100;
var comparisonSlider;
var targetSize = 100;
var targets = [100];



var allQuestionsStatus=0;

/*
 *	For trial by trial info, want 5 columns:
 *
 */
var CLLab = {
	labName : "Muller-Lyer",
	language : "en",
	theDevice : "Computer",
	addToGlobal : 0,
	labTime : 0,
	numTrials : numberOfTrials,
	numConds : numberOfConditions,
	numCols : 5,
	trials : [],
	statistics : [],
	questions : [],
	TBTSummary : "On each trial, you adjusted the length of line without wings so that it matched the length of a line with wings.",
	TBTInfo : []
};


/*
 *	This function is called first when the page gets fully loaded
 */
function load() {
	$('#lab_space').css( {'position':'relative', 'left':0 } );	
	
    canvas = document.getElementById("lab_display");
    ctx = canvas.getContext("2d");
    enhanceContext(canvas, ctx);	// for retina displays
 	ctx.font="24px Helvetica"; 	// "italic small-caps bold 12px arial";
	ctx.fillStyle="#000000";
	ctx.fillRect(0,0,width,height);
		
	var ttg = numberOfTrials;
	$('#trialsToGo').html('<p>Trials to go: ' + ttg + '</p>');

	
 	respBut = document.getElementById("respBut");
 	startBut = document.getElementById("startBut");
	comparisonSlider = document.getElementById("comparisonSlider");
	
	var ttg = numberOfTrials - trialCounter;
	$('#trialsToGo').html('<p>Trials to go: ' + ttg + '</p>');

	/*
	 * binds the keydown event to keydownControl which means that keydownControl 
	 * function will be called whenever any key is pressed
	 */
  //  window.onkeydown = keydownControl;
    
    // Set up dialog asking about saving to global data, but don't show yet
	$('#global_dialog').dialog({
		autoOpen: false,
		modal: true,
		closeOnEscape: false,
		draggable: false,
		resizable: false,
		closeText: 'hide',
		width: 500,
		open: function(event, ui) { jQuery('.ui-dialog-titlebar-close').hide(); },
		buttons: {
			"Yes": function() {
				CLLab.addToGlobal = 1;
				$( this ).dialog( "close" );
				$('#global_dialog').css( {'position':'absolute', 'left':'-999em' } );
				theParams = JSON.stringify( CLLab );
				$.post('/sls?addData',theParams,processData).error(errorResponse);
				$( this ).dialog( "destroy" );
			},
			"No": function() {
				CLLab.addToGlobal = 0;
				$( this ).dialog( "close" );
				$('#global_dialog').css( {'position':'absolute', 'left':'-999em' } );
				theParams = JSON.stringify( CLLab );
				$.post('/sls?addData',theParams,processData).error(errorResponse);
				$( this ).dialog( "destroy" );
			}
		}
	});

	// Note the time, in milliseconds since the epoch
	labStartTime = new Date().getTime();
	DefineTrials();
}

/*
 *	Sets up the order of the conditions
 */
function DefineTrials() {

	for ( i = 0; i < numberOfTrials; i+=1 ) {	
		var newTrial = [];
		newTrial[0] = targets[0]; 
		TrialsToGo[i] = newTrial;
	}
		
}

/*
 *	Called when the start button receives mouse down
 */
function pressMDStart() {
	
		document.getElementById('startBut').disabled = true; 
		press0();		
	
}

/*
 *	Called when the start button receives touch start
 */
function pressOTStart() {
	
	document.getElementById('startBut').disabled = true; 
	press0();		
}

/*
 *	Called when the start button is clicked/tapped
 */
function press0() {
	
	if ( whichPhase == NOT_IN_TRIAL ) {
		whichPhase = WAITING_FOR_STIMULUS;
		document.getElementById('startBut').disabled = true; 
		clearCanvas();
		drawStimuli();

	}		
}

/*
 *	Erases the whole canvas
 */
function clearCanvas() {
	ctx.fillStyle="#000000";
    ctx.fillRect(0,0,width,height);
}
 

/*
 *	Draws the stimuli
 */
function drawStimuli() {

	currentTrial = TrialsToGo[0];
	targetSize = 100
	TrialsToGo.shift();
	
	/*
	 *	Canvas is 900 wide, 600 high.
	 */
	clearCanvas();
	
	// Draw target on right side
	// Right side target
	ctx.beginPath();
	ctx.lineWidth = 3;
	ctx.strokeStyle="White";	
	ctx.moveTo(3*width/4, 2*height/3- targetSize/2);
	ctx.lineTo(3*width/4, 2*height/3+ targetSize/2);
	
	// Top outer wings
	ctx.moveTo(3*width/4, 2*height/3- targetSize/2);
	ctx.lineTo(3*width/4-20, 2*height/3- targetSize/2-20);
	ctx.moveTo(3*width/4, 2*height/3- targetSize/2);
	ctx.lineTo(3*width/4+20, 2*height/3- targetSize/2-20);	
	ctx.moveTo(3*width/4, 2*height/3 + targetSize/2);
	ctx.lineTo(3*width/4-20, 2*height/3 + targetSize/2+20);	
	ctx.moveTo(3*width/4, 2*height/3 + targetSize/2);
	ctx.lineTo(3*width/4+20, 2*height/3 + targetSize/2+20);				
	ctx.stroke();
	ctx.closePath();
	
	
	trialStartTime = new Date().getTime();
	whichPhase = WAITING_FOR_RESPONSE;
	document.getElementById('matchBut').disabled = true; 
	
	// starting point is half-way between min and max values
	var min = 0;
	var max = 200 + Math.round( 25*(Math.random()));
	var theLength = currentTrial;
	while(Math.abs(theLength-currentTrial)<3){
		theLength = min + Math.round( Math.random() * (max - min) ); 
	}

	document.getElementById('comparisonSlider').min = min;
	document.getElementById('comparisonSlider').max = max;
	document.getElementById('comparisonSlider').value = theLength
	document.getElementById('comparisonSlider').disabled = false;
	drawComparisonLine( theLength );
	trialStartTime = new Date().getTime();
	whichPhase = WAITING_FOR_RESPONSE;	
	document.getElementById('matchBut').disabled = true; 
	
}

/*
 *
 */
function drawComparisonLine(length) {

	document.getElementById('matchBut').disabled = false; 

	theLength = Math.round(10*length)/10.0;  // needed to insure it is a true number

	// Clear half of screen
	ctx.fillStyle="#000000";
    ctx.fillRect(0,0,width/2,height);

	// Left side adjustable line
	ctx.beginPath();
	ctx.lineWidth = 3;
	ctx.strokeStyle="White";	
	ctx.moveTo(width/4,height/3- theLength/2);
	ctx.lineTo(width/4,height/3 +length/2);
				
	ctx.stroke();
	ctx.closePath();
}


/*
 *	Called when the present button receives mouse down
 */
function pressMD() {
	
		press1( 'Present' );		
}

/*
 *	Called when the present button receives touch start
 */
function pressOT() {
	
	press1( 'Present' );		
}



/*
 *	Called when a response button is clicked/tapped
 */
function press1( theResponse ) {
	
	if ( whichPhase == WAITING_FOR_RESPONSE ) {
		whichPhase = PROCESSING_RESPONSE;

		// ready for a response
		document.getElementById('matchBut').disabled = true; 
		document.getElementById('comparisonSlider').disabled = true;
		clearCanvas();
		
		if ( debugIt) {
			console.log(
				'trialCounter = ' + trialCounter + 
				'targetSize = ' + targetSize + 
				'; theLength ' + theLength );
		}
		
		// Add trial info to JSON
		// Given labels that respect the TBTInfo
		CLLab.trials.push({
			trialNum : trialCounter+1,
			Dconditions0 : targetSize,
			Dresponses0 : theLength			// matching length
		});
		
		trialCounter++;

		if ( trialCounter == numberOfTrials ) {
			whichPhase = END_OF_LAB;
			labEndTime = new Date().getTime();
			CLLab.labTime = labEndTime - labStartTime;
			
			var ttg = numberOfTrials - trialCounter;
			$('#trialsToGo').html('<p>Trials to go: ' + ttg + '</p>');

			clearCanvas();
			drawMsgCentred( "Compiling data..." );
			
			/* Answers */
			var sumX1=0.0;
			var sumX2= 0.0;
			var sumX3= 0.0;
			var countX1=0;
			var countX2=0;
			var countX3=0;

	
			for ( i = 0; i < numberOfTrials; i++ ) {
				if(CLLab.trials[i].Dconditions0 == targets[0]){
					countX1++;
					sumX1 += CLLab.trials[i].Dresponses0;
				}
				else if(CLLab.trials[i].Dconditions0 == targets[1]){
					countX2++;
					sumX2 += CLLab.trials[i].Dresponses0;
				}
				else if(CLLab.trials[i].Dconditions0 == targets[2]){
					countX3++;
					sumX3 += CLLab.trials[i].Dresponses0;
				}				
			}	
	
			var meanX1 = sumX1/countX1;
			var meanX2 = sumX2/countX2;
			var meanX3 = sumX3/countX3;

			var SS1=0.0;
			var SS2=0.0;
			var SS3=0.0;

			for ( i = 0; i < numberOfTrials; i++ ) {
				if(CLLab.trials[i].Dconditions0 == targets[0]){
					SS1 += (meanX1 - CLLab.trials[i].Dresponses0) * (meanX1 - CLLab.trials[i].Dresponses0);
				}
				else if(CLLab.trials[i].Dconditions0 == targets[1]){
					SS2 += (meanX2 - CLLab.trials[i].Dresponses0) * (meanX2 - CLLab.trials[i].Dresponses0);
				}
				else if(CLLab.trials[i].Dconditions0 == targets[2]){
					SS3 += (meanX3 - CLLab.trials[i].Dresponses0) * (meanX3 - CLLab.trials[i].Dresponses0);
				}				
			}	

			var sd1=Math.sqrt(SS1/(countX1-1));
			var sd2=Math.sqrt(SS2/(countX2-1));
			var sd3=Math.sqrt(SS3/(countX3-1));
			
			// Add statistics info to JSON
			CLLab.statistics.push({
				Label : "Mean for target size "+targets[0],
				value : meanX1
			});			
			CLLab.statistics.push({
				Label : "Standard deviation for target size "+targets[0],
				value : sd1
			});		
			
			// Display data summary information
			var summaryTable = "<table> <tr><th>Statistic</th><th>Value</th></tr>";
			for(i=0;i<CLLab.statistics.length;i++){
				summaryTable += "<tr><td> "+CLLab.statistics[i].Label+"</td><td>"+CLLab.statistics[i].value+"</td></tr>";
			}
			summaryTable += "</table>";
			$('#dataSummary').html(summaryTable);
						
			// Add trial-by-trial formatting information		
			CLLab.TBTInfo.push({
				Label : "Target line length (pixels)",  // Column header
				Point1 : 1,  // 0 - SConditions, 1 - DCondtions, 2 - SResponse, 3 - DResponse
				Point2 : 0
			});					
			CLLab.TBTInfo.push({
				Label : "Matching line length (pixels)",  // Column header
				Point1 : 3,  // 0 - SConditions, 1 - DCondtions, 2 - SResponse, 3 - DResponse
				Point2 : 0
			});		

			// Display trial by trial information
			var TBTtable = "<table> <tr>";
			for(i=0;i<CLLab.TBTInfo.length;i++)
				TBTtable+= "<th>"+CLLab.TBTInfo[i].Label+"</th>";
			TBTtable+="</tr>";
			// Add in row for each trial
			for(j=0;j<CLLab.trials.length;j++){
				TBTtable+="<tr>";
				for(i=0;i<CLLab.TBTInfo.length;i++){
					TBTtable+="<td>";
					var temp = "";
					if(CLLab.TBTInfo[i].Point1==0){
						if(CLLab.TBTInfo[i].Point2==0)
							temp = CLLab.trials[j].Sconditions0;
						if(CLLab.TBTInfo[i].Point2==1)
							temp = CLLab.trials[j].Sconditions1;					
						if(CLLab.TBTInfo[i].Point2==2)
							temp = CLLab.trials[j].Sconditions2;	
						if(CLLab.TBTInfo[i].Point2==3)
							temp = CLLab.trials[j].Sconditions3;	
					}
					if(CLLab.TBTInfo[i].Point1==1){
						if(CLLab.TBTInfo[i].Point2==0)
							temp = CLLab.trials[j].Dconditions0;
						if(CLLab.TBTInfo[i].Point2==1)
							temp = CLLab.trials[j].Dconditions1;					
						if(CLLab.TBTInfo[i].Point2==2)
							temp = CLLab.trials[j].Dconditions2;	
						if(CLLab.TBTInfo[i].Point2==3)
							temp = CLLab.trials[j].Dconditions3;	
					}		
					if(CLLab.TBTInfo[i].Point1==2){
						if(CLLab.TBTInfo[i].Point2==0)
							temp = CLLab.trials[j].Sresponses0;
						if(CLLab.TBTInfo[i].Point2==1)
							temp = CLLab.trials[j].Sresponses1;					
						if(CLLab.TBTInfo[i].Point2==2)
							temp = CLLab.trials[j].Sresponses2;	
						if(CLLab.TBTInfo[i].Point2==3)
							temp = CLLab.trials[j].Sresponses3;	
					}
					if(CLLab.TBTInfo[i].Point1==3){
						if(CLLab.TBTInfo[i].Point2==0)
							temp = CLLab.trials[j].Dresponses0;
						if(CLLab.TBTInfo[i].Point2==1)
							temp = CLLab.trials[j].Dresponses1;					
						if(CLLab.TBTInfo[i].Point2==2)
							temp = CLLab.trials[j].Dresponses2;	
						if(CLLab.TBTInfo[i].Point2==3)
							temp = CLLab.trials[j].Dresponses3;	
					}
					TBTtable += temp+"</td>";
			}
			TBTtable += "</tr>";
			
			}
			TBTtable += "</table>";
			
			$('#tbt').html(TBTtable);			
			
			$('#lab_space').css( {'position':'absolute', 'left':'-999em' } );  // hide lab
			$('#the_results').css( {'position':'relative', 'left':0 } ); // show results
			showAccordian();
			
		} else {
			whichPhase = NOT_IN_TRIAL;
			var ttg = numberOfTrials - trialCounter;
			$('#trialsToGo').html('<p>Trials to go: ' + ttg + '</p>');
			document.getElementById('startBut').disabled = false; 
		}
	}
}



/*
/*
 *	keycode0 next trial
 *	keycode1 present
 *	keycode2 absent
 */
function keydownControl(e) {
	if (e.keyCode==keycode2) {
		press1('Absent');
    }
	if (e.keyCode==keycode1) {
		press1('Present');
    }
	if (e.keyCode==keycode0) {
		press0();
    }
}

/*
 *	Adjusts responses based on keyboard layout
 */

function setKeyboard( sel, whichOne ) {
	var kbd;
	var ak;
	
	if ( whichOne.length > 0 )
		kbd = whichOne;
	else
		kbd = sel.options[sel.selectedIndex].value;

	if ( kbd != 'Change keyboard layout' ) {
		if ( kbd === 'QWERTY' || kbd === 'QWERTY_CSA' || kbd === 'QWERTY_VAR' || kbd === 'QWERTZ' || kbd === 'AZERTY' ) {
			ak = getKeyCode( kbd, 'n' );	/* next trial */
			$('#key0').html(ak.theEquivKey);
			keycode0 = ak.theKeyCode;

			ak = getKeyCode( kbd, 'm' );	/* present */
			$('#key1').html(ak.theEquivKey);
			$('#key2').html(ak.theEquivKey);
			keycode1 = ak.theKeyCode;

			ak = getKeyCode( kbd, 'z' );	/* absent */
			$('#key3').html(ak.theEquivKey);
			keycode2 = ak.theKeyCode;
		} else {
			window.open('/info/keyboards.shtml', '_blank');
		}
	}
}


/*
 *	Draws msg to screen
 */
function drawMsg(m) {
	ctx.textAlign="left"; 
	ctx.fillStyle="#FFFFFF";
	ctx.fillText( m, 10, 20);
}

/*
 *	Draws msg to screen
 */
function drawMsgCentred(m) {
	// middle of text will be at point specified
	ctx.textAlign="center"; 
	ctx.fillStyle="#FFFFFF";
	ctx.fillText( m, 300, 200);
}

/**
*	Make canvas look non-blurry on retina displays
*/
function enhanceContext(canvas, context) {
	var ratio = window.devicePixelRatio || 1,
		width = canvas.width,
		height = canvas.height;

	if (ratio > 1) {
		canvas.width = width * ratio;
		canvas.height = height * ratio;
		canvas.style.width = width + "px";
		canvas.style.height = height + "px";
		context.scale(ratio, ratio);
	}
}

window.addEventListener("load",load,true);